# Taken and Modified from trac / GPL

import datetime
from dateutil.parser import parse

_units = (
    (3600*24*365, '%d year'),
    (3600*24*30,  '%d month'),
    (3600*24*7,   '%d week'),
    (3600*24,     '%d day'),
    (3600,        '%d hour'),
    (60,          '%d minute')
    )

def pretty_timedelta(time1, time2=None):
    """Calculate time delta between two `datetime` objects.
    (the result is somewhat imprecise, only use for prettyprinting).
    """
    if isinstance(time1, (str, unicode)):
        time1 = parse(time1)
    if time2 is None:
        time2 = datetime.datetime.now()
    diff = time2 - time1
    age_s = int(diff.days * 86400 + diff.seconds)

#    if age_s <= 60 * 1.9:
#        return ngettext('%(num)i second', '%(num)i seconds', age_s)
    for u, template in _units:
        r = float(age_s) / float(u)
        if r >= 1.9:
            r = int(round(r))
            v = template % r
            if r > 1:
                v += "s"
            return v
    return ''


if __name__ == '__main__':
    print "pretty time delta"
    print pretty_timedelta(
        datetime.datetime(year=2012, month=3, day=1))

    print pretty_timedelta(
        (datetime.datetime.now()-datetime.timedelta(10)))
